/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: ShoppingClMsgMgr.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#ifndef ShoppingClMsgMgr_H
#define ShoppingClMsgMgr_H

#include "ProductList.h"

#include <stdio.h>

int
GetProductCount(const char *endpoint,
				const char *soapAction,
				const char *charEnc,
				long *count);
	
int
GetProductSpec(const char *endpoint,
			   const char *soapAction,
			   const char *charEnc,
			   long index,
			   ProductListItemPtr product);
    
int
GetStockQty(const char *endpoint,
			const char *soapAction,
			const char *charEnc,
			const char *code,
			long *qty);
	
/* this return value shuld call free() after using */
int
PlaceOrder(const char *endpoint,
		   const char *soapAction,
		   const char *charEnc,
		   const char *code,
		   long qty,
		   char **confirmation);

int
PlaceOrderAsync(const char *endpoint,
				const char *soapAction,
				const char *charEnc,
				const char *code,
				long qty,
				FILE *fp);

int
ConfirmOrder(FILE *fp,
			 const char *endpoint,
			 const char *soapAction,
			 const char *charEnc,
			 char **confirmation);

#endif /* ShoppingClMsgMgr_H */
