/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: Serializer.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */
#ifndef OpenSOAP_Impl_Serializer_H
#define OpenSOAP_Impl_Serializer_H

#include <OpenSOAP/Serializer.h>

#define	OPENSOAP_SERIALIZER_NAME(type_name) 	OpenSOAPSerializer##type_name
#define	OPENSOAP_DESERIALIZER_NAME(type_name) 	OpenSOAPDeerializer##type_name

#define	OPENSOAP_SERIALIZER_DECLARE(type_name) \
int \
OpenSOAPSerializer##type_name(/* [in] */  void *from_value, \
							  /* [out] */ OpenSOAPStringPtr to)

#define	OPENSOAP_DESERIALIZER_DECLARE(type_name) \
int \
OpenSOAPDeserializer##type_name(/* [in] */  OpenSOAPStringPtr from, \
								/* [out] */ void *to_value)

#define	OPENSOAP_SERIALIZER_DEFINITION(type_name) \
int \
OpenSOAPSerializer##type_name(/* [in] */  void *from_value, \
							  /* [out] */ OpenSOAPStringPtr to)

#define	OPENSOAP_DESERIALIZER_DEFINITION(type_name) \
int \
OpenSOAPDeserializer##type_name(/* [in] */  OpenSOAPStringPtr from, \
								/* [out] */ void *to_value)


#define OPENSOAP_SERIALIZER_REGIST_INFO_ITEM(type_name) \
	{ \
		L ## #type_name, \
		OpenSOAPSerializer##type_name, \
		OpenSOAPDeserializer##type_name \
	}

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* OpenSOAP_Impl_Serializer_H */
