/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: ChannelSelector.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#ifndef _ChannelSelector_H_
#define _ChannelSelector_H_

#include <string>

#include "ChannelDescriptor.h"

namespace OpenSOAP {

  //ChannelManagerƂ̂ƂɂDescriptor𓾂
  class ChannelSelector {

  public:
    virtual ~ChannelSelector();
  
  protected:
    ChannelSelector();
    ChannelSelector(const std::string& addr);

  public:
    virtual int open(ChannelDescriptor& chnlDesc, 
		     const int waitSecond = ChannelDescriptor::NO_WAIT);
    virtual int close(ChannelDescriptor& chnlDesc);

  protected:
    void setSocketAddr(const std::string& addr);

    //ChannelManagerƂ̒ʐMoHm
    int connectChannelManager();

    virtual std::string makeSendOpenMessage(const int waitSecond);
    virtual std::string makeSendCloseMessage();

    //ChannelManagerƂ̒ʐMoHw
    std::string socketAddr_;
    
  };

} // end of namespace OpenSOAP


#endif _ChannelSelector_H_
