/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: HTTPMessage.cpp,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#include <algorithm>
#include <iostream>
#include <string>
#include "HTTPMessage.h"
#include "StringUtil.h"

using namespace std;


std::string
createHTTPMessage (const std::string &cgiLocation,
                   const std::string &soapMsg,
                   const std::string &soapAction)
{
    std::string head1 = std::string ("POST ") + cgiLocation
      + std::string (" HTTP/1.0\n");
    std::string actionHeader = "SOAPAction: \"" + soapAction + "\"\n";
//  #if 1
//      // for MSSoap srvdrv
//      actionHeader += "http://tempuri.org/action/Calc.";
//      actionHeader += method;
//  #endif
//      actionHeader += "\"\n";
    std::string head2 = std::string("Content-Length: ") 
      + StringUtil::toString(soapMsg.length()) + std::string ("\n\n");
    
    std::string httpMsg = head1 + actionHeader + head2 + soapMsg;
  
    return httpMsg;
}

std::string
removeHTTPHeader (std::string& recvMsg)
{
  char delim = '<';
  std::string::iterator openBraceLoc
    = find (recvMsg.begin(), recvMsg.end (), delim);
  if (openBraceLoc == recvMsg.end()) {
    cerr << "HTTP Message does not contain SOAP Message !" << endl;
    return std::string ("");
  }
  std::string soapMsg = std::string(openBraceLoc, recvMsg.end());
  
  return soapMsg;
}
